#!/bin/sh
#set -vx

# variables changed
# ARTSDIR
# RRDTOOL_LOC
# CGIDIR
# NETFLOWPOLL

# parameters
CFLOWD_DB="ARTSDIR/data/cflowd/databases"
RRDTOOL=RRDTOOL_LOC
WORK_DIR=CGIDIR
POLLER_CONFIG="$WORK_DIR/poller.cfg"

if [ -f $POLLER_CONFIG ]
then
  . $POLLER_CONFIG 
fi

ROUTER=$1
FLOW=$2

# when we obtain the rrd data for the last hour, 13 or 14 lines of data will always be printed
# so we head the output to 13 lines to filter out extra output
RRD_DATA=`$RRDTOOL fetch $CFLOWD_DB/$FLOW.rrd AVERAGE -s e-1h \
   | tac | head -n 13 | awk '{\
                    time=$1; incount=$2; outcount=$3;\
          }\
          $3!="nan" {\
                    printf("%d\n%d\n%d\n",NETFLOWPOLL*outcount,NETFLOWPOLL*incount,time); \
                    exit;\
          }\
          END {\
                    printf("0\n0\n%d\n", time);\
          }'`
INBYTE=`echo $RRD_DATA | awk '{print $2}'`
OUTBYTE=`echo $RRD_DATA | awk '{print $1}'`
TIME=`echo $RRD_DATA | awk '{print $3}'`


if [ -f $WORK_DIR/$FLOW.time ]
then
   LASTDATE=`cat $WORK_DIR/$FLOW.time`
   if [ .$LASTDATE = .$TIME ]
   then
     OUTBYTE=`cat $WORK_DIR/$FLOW.out`
     INBYTE=`cat $WORK_DIR/$FLOW.in`
   else 

      if [ -f $WORK_DIR/$FLOW.out ]
      then
         OFFSET=`cat $WORK_DIR/$FLOW.out`
         OUTBYTE=`$WORK_DIR/add $OFFSET $OUTBYTE`
      fi
      if [ -f $WORK_DIR/$FLOW.in ]
      then
         OFFSET=`cat $WORK_DIR/$FLOW.in`
         INBYTE=`$WORK_DIR/add $OFFSET $INBYTE`
      fi
    fi
fi

echo "Content-type: text/html"
echo ""
echo $OUTBYTE > $WORK_DIR/$FLOW.out
echo "$OUTBYTE"
echo $INBYTE > $WORK_DIR/$FLOW.in
echo "$INBYTE"
echo $TIME > $WORK_DIR/$FLOW.time
echo "$TIME"
echo "$FLOW"
