#!/bin/sh
# rrd-juni-log.cgi  a script to generate traffic data in plain text
# graphs with stats from RRDs 
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
# Author: nemo@invisiblehand.net
# Version: $Revision: 1.2 $, $Date: 2003/07/11 19:03:57 $
# Copyright (C) 2002-2003 by Invisible Hand Networks, Inc.
# 
# Usage:  
#      rrd-log.sh <flow-name> [<window> <last_timestamp>]
#      rrd-log.cgi FLOW=<flow-name> [WINDOW=<window> LAST_TIMESTAMP=<last_timestamp>]
#
# Moving window of up to <window>, i.e. returns all data going back to 
# (current-time - <window>) or to  <last_timestamp>
# whichever is more recent.
# If <last_timestamp> is omitted it is equiv to time 0. 
# If <window> is omitted,  behaves like it is infinity, i.e. you get all data.
#

source ../../conf/tmon.conf
# params given on command line
FLOW=$1
WINDOW=$2
LAST_TIMESTAMP=$3

# params given via env (when run as  CGI) in the form key1=value1&key2=value2...
if [ .$QUERY_STRING = . ]
then 
    echo "no query string" >> $LOGFILE
else
#    echo "Request from: "$REMOTE_ADDR >> $LOGFILE
#    echo "$QUERY_STRING" >> $LOGFILE
    FLOW=`echo "$QUERY_STRING" | $AWK 'BEGIN{RS="&"; FS="=";}($1 == "FLOW") { flow=$2;} END{print flow;}' -`
    WINDOW=`echo "$QUERY_STRING" | $AWK 'BEGIN{RS="&"; FS="=";}($1 == "WINDOW") { window=$2;} END{print window;}' -`
    LAST_TIMESTAMP=`echo "$QUERY_STRING" | $AWK 'BEGIN{RS="&"; FS="=";}($1 == "LAST_TIMESTAMP") { last=$2;} END{print last;}' -`
fi

# params given via env (when run as  CGI) in the form value1+value2...

if [ .$FLOW = . ]
then
    FLOW=`echo "$QUERY_STRING" | $AWK 'BEGIN{RS="+";} (NR==1)' -`
fi

if [ .$WINDOW = . ]
then 
   WINDOW=`echo "$QUERY_STRING" | $AWK 'BEGIN{RS="+";} (NR==2)' -`
fi

if [ .$LAST_TIMESTAMP = . ]
then
    LAST_TIMESTAMP=`echo "$QUERY_STRING" | $AWK 'BEGIN{RS="+";} (NR==3)' -`
fi

# start = max(current - window, last)
CURRENT_TIME=`date +"%s"` 

if [ .$WINDOW = . ]
then
    HORIZON="0"
else 
    HORIZON=`expr $CURRENT_TIME - $WINDOW`
fi

if [ .$LAST_TIMESTAMP = . ]
then
    LAST_TIMESTAMP="0"
fi

if [ $HORIZON -gt $LAST_TIMESTAMP ]
then
    STARTING_TIMESTAMP=$HORIZON
else
    STARTING_TIMESTAMP=$LAST_TIMESTAMP
fi


echo "Content-type: text/plain"
echo ""
$RRDTOOL fetch $CFLOWD_DB/$FLOW.rrd AVERAGE -r $RESOLUTION -s $STARTING_TIMESTAMP\
    | tac |  $AWK -v sample_rate=$SAMPLE_RATE 'match($2,/[[:digit:]]/) { \
    printf("%d\t %d\t %d\n", substr($1,0,length($1)-1), 0, $3*sample_rate)}' 






